\section{Tables}\label{sec:tables}

The tables module provides main data structures for NFD.

The Forwarding Information Base (FIB) (Section~\ref{sec:tab-fib}) is used to forward Interest packets toward potential source(s) of matching Data.
It's almost identical to an IP FIB except it allows for a list of outgoing faces rather than a single one.

The Network Region Table (Section~\ref{sec:tab-nrt}) contains a list of producer region names for mobility support.

The Content Store (CS) (Section~\ref{sec:tab-cs}) is a cache of Data packets.
Arriving Data packets are placed in this cache as long as possible, in order to satisfy future Interests that request the same Data.

The Interest Table (PIT) (Section~\ref{sec:tab-pit}) keeps track of Interests forwarded upstream toward content source(s), so that Data can be sent downstream to its requester(s).
It also contains recently satisfied Interests for loop detection and measurements purposes.

The Dead Nonce List (Section~\ref{sec:tab-dnl} supplements the Interest Table for loop detection.

The Strategy Choice Table (Section~\ref{sec:tab-sc}) contains the forwarding strategy (Section~\ref{sec:strategy}) chosen for each namespace.

The Measurements Table (Section~\ref{sec:tab-m}) is used by forwarding strategies to store measurements information regarding a name prefix.

FIB, PIT, Strategy Choice Table, and Measurements Table have much commonality in their index structure.
To improve performance and reduce memory usage, a common index, the Name Tree (Section~\ref{sec:tab-nt}), is designed to be shared among these four tables.

\input{tab-fib}
\input{tab-nrt}
\input{tab-cs}
\input{tab-pit}
\input{tab-dnl}
\input{tab-sc}
\input{tab-m}
\input{tab-nt}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "nfd-docs"
%%% End:
